package model

import (
	"fmt"
	"github.com/fonchain/fonchain-artistinfo/cmd/model/old"
	"os"
	"strings"
	"time"

	"github.com/fonchain/fonchain-artistinfo/cmd/model"
	"github.com/fonchain/fonchain-artistinfo/pkg/m"
	"github.com/gin-gonic/gin"
	"gopkg.in/ini.v1"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"gorm.io/gorm/schema"
)

var DB *gorm.DB

var (
	Db         string
	DbHost     string
	DbPort     string
	DbUser     string
	DbPassWord string
	DbLogName  string
)

func Init(confPath string) {
	//从本地读取环境变量
	file, err := ini.Load(confPath)
	if err != nil {
		fmt.Println(m.ERROR_SERVER, err)
	}
	//加载数据库配置
	LoadMysqlData(file)

	//MySQL数据库
	path := strings.Join([]string{DbUser, ":", DbPassWord, "@tcp(", DbHost, ":", DbPort, ")/", DbLogName, "?charset=utf8&parseTime=true"}, "")
	//连接数据库
	Database(path)
	//迁移表 如果需要就打开使用
	migration()
	// 生成视图 ，如果更新报错需要手动删除视图后再执行程序
	if err = generateModelView(
		model.CreateUserView, //用户表视图
	); err != nil {
		fmt.Println("创建或更新视图失败，错误内容:", err.Error())
		os.Exit(1)
	}
}

func LoadMysqlData(file *ini.File) {
	Db = file.Section("mysql").Key("Db").String()
	DbHost = file.Section("mysql").Key("DbHost").String()
	DbPort = file.Section("mysql").Key("DbPort").String()
	DbUser = file.Section("mysql").Key("DbUser").String()
	DbPassWord = file.Section("mysql").Key("DbPassWord").String()
	DbLogName = file.Section("mysql").Key("DbName").String()
}

func Database(conn string) {
	var ormLogger logger.Interface
	if gin.Mode() == "debug" {
		ormLogger = logger.Default.LogMode(logger.Info)
	} else {
		ormLogger = logger.Default
	}
	db, err := gorm.Open(mysql.New(mysql.Config{
		DSN:                       conn,  // DSN data source name
		DefaultStringSize:         256,   // string 类型字段的默认长度
		DisableDatetimePrecision:  true,  // 禁用 datetime 精度，MySQL 5.6 之前的数据库不支持
		DontSupportRenameIndex:    true,  // 重命名索引时采用删除并新建的方式，MySQL 5.7 之前的数据库和 MariaDB 不支持重命名索引
		DontSupportRenameColumn:   true,  // 用 `change` 重命名列，MySQL 8 之前的数据库和 MariaDB 不支持重命名列
		SkipInitializeWithVersion: false, // 根据版本自动配置
	}), &gorm.Config{
		Logger: ormLogger,
		NamingStrategy: schema.NamingStrategy{
			SingularTable: true,
		},
		DisableForeignKeyConstraintWhenMigrating: true, //表结构迁移时禁用外键约束（不会添加外键关联）
	})
	sqlDB, _ := db.DB()
	sqlDB.SetMaxIdleConns(20)  //设置连接池，空闲
	sqlDB.SetMaxOpenConns(100) //打开
	sqlDB.SetConnMaxLifetime(time.Second * 30)
	DB = db
	if err != nil {
		panic(err)
	}
}

func migration() {
	//自迁移模式
	err := DB.AutoMigrate(
		&old.Bank{},
		&model.RealName{},
		&model.User{},
		&model.Invite{},
		&old.Artwork{},
		//&model.Contract{},
		//&model.SupplyInfo{},
		//&model.ExhVideo{},
		//&model.ExhExam{},
		&old.ArtistInfo{},
		&model.UserInvited{},
		&old.ArtworkState{},
		&old.ArtworkBatch{},
		&model.TempArtistInfo{},
		&model.ArtworkLockRecord{},
		&model.ArtshowVideoRecord{},      //画展视频记录
		&model.ArtshowArtistIndex{},      //画展-画家指数
		&model.ArtshowArtistSupplement{}, //画展-画家补充信息
	)
	if err != nil {
		fmt.Println("register table fail")
		//os.Exit(0)
	}
	fmt.Println("register table success")
}

// 创建视图
func generateModelView(functions ...func(db *gorm.DB) error) (err error) {
	if functions == nil {
		return
	}
	for _, viewFunc := range functions {
		err = viewFunc(DB)
		if err != nil {
			return err
		}

	}
	return nil
}
